package main

import (
	"bufio"
	"log"
	"os"
)

// readlines reads lines from stdin.
// Then it returns them as an array of strings
func readlines() []string {
	lines := []string{}

	scanner := bufio.NewScanner(os.Stdin)
	for scanner.Scan() {
		lines = append(lines, scanner.Text())
	}

	if err := scanner.Err(); err != nil {
		log.Fatal(err)
	}

	return lines
}

// reverse accepts a string and returns its reverse
func reverse(s string) (result string) {
	for _, v := range s {
		result = string(v) + result
	}
	return
}
